<?php
/**
 * Landofcoder
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Landofcoder.com license that is
 * available through the world-wide-web at this URL:
 * http://landofcoder.com/license
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category   Landofcoder
 * @package    Lof_SocialLogin
 *
 * @copyright  Copyright (c) 2016 Landofcoder (http://www.landofcoder.com/)
 * @license    http://www.landofcoder.com/LICENSE-1.0.html
 */

namespace Lof\SocialLogin\Block\Widget;

use Lof\SocialLogin\Block\SocialLogin\Amazon;
use Lof\SocialLogin\Block\SocialLogin\Disqus;
use Lof\SocialLogin\Block\SocialLogin\Dropbox;
use Lof\SocialLogin\Block\SocialLogin\Facebook;
use Lof\SocialLogin\Block\SocialLogin\Github;
use Lof\SocialLogin\Block\SocialLogin\Google;
use Lof\SocialLogin\Block\SocialLogin\Instagram;
use Lof\SocialLogin\Block\SocialLogin\Linkedin;
use Lof\SocialLogin\Block\SocialLogin\Paypal;
use Lof\SocialLogin\Block\SocialLogin\Pinterest;
use Lof\SocialLogin\Block\SocialLogin\Soundcloud;
use Lof\SocialLogin\Block\SocialLogin\Stackoverflow;
use Lof\SocialLogin\Block\SocialLogin\Vimeo;
use Lof\SocialLogin\Block\SocialLogin\Twitter;
use Lof\SocialLogin\Block\SocialLogin\Wordpress;

class Login extends \Magento\Framework\View\Element\Template implements \Magento\Widget\Block\BlockInterface
{
    protected $_authenicationBlock;
    protected $_amazon;
    protected $_disqus;
    protected $_dropbox;
    protected $_facebook;
    protected $_github;
    protected $_google;
    protected $_instagram;
    protected $_linkedin;
    protected $_paypal;
    protected $_pinterest;
    protected $_soundcloud;
    protected $_stackoverflow;
    protected $_twitter;
    protected $_vimeo;
    protected $_wordpress;
    /*
    * @var \Magento\Customer\Model\Session
    */
    protected $_customerSession;
    
    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
        \Magento\Customer\Model\Session $customerSession,
        Amazon $amazon,
        Disqus $disqus,
        Dropbox $dropbox,
        Facebook $facebook,
        Github $github,
        Google $google,
        Instagram $instagram,
        Linkedin $linkedin,
        Paypal $paypal,
        Pinterest $pinterest,
        Soundcloud $soundcloud,
        Stackoverflow $stackoverflow,
        Twitter $twitter,
        Vimeo $vimeo,
        Wordpress $wordpress,
        array $data = []
    ) {
        $this->_amazon        = $amazon;
        $this->_disqus        = $disqus;
        $this->_dropbox       = $dropbox;
        $this->_facebook      = $facebook;
        $this->_github        = $github;
        $this->_google        = $google;
        $this->_instagram     = $instagram;
        $this->_linkedin      = $linkedin;
        $this->_paypal        = $paypal;
        $this->_pinterest     = $pinterest;
        $this->_soundcloud    = $soundcloud;
        $this->_stackoverflow = $stackoverflow;
        $this->_twitter       = $twitter;
        $this->_vimeo         = $vimeo;
        $this->_wordpress     = $wordpress;
        $this->_customerSession = $customerSession;
        parent::__construct($context, $data);
    }

    public function _toHtml()
    {
        $this->setTemplate('Lof_SocialLogin::widget/login.phtml');
        return parent::_toHtml();
    }

    public function checkLogin() {
        return $this->_customerSession->isLoggedIn();
    }

    public function getLoginUrl($value)
    {
        if ($value) {
            switch ($value) {
                case 'amazon':
                    return $this->_amazon->getLoginUrl();
                break;
                case 'disqus':
                    return $this->_disqus->getLoginUrl();
                break;
                case 'dropbox':
                    return $this->_dropbox->getLoginUrl();
                break;
                case 'facebook':
                    return $this->_facebook->getLoginUrl();
                break;
                case 'github':
                    return $this->_github->getLoginUrl();
                break;
                case 'google':
                    return $this->_google->getLoginUrl();
                break;
                case 'instagram':
                    return $this->_instagram->getLoginUrl();
                break;
                case 'linkedin':
                    return $this->_linkedin->getLoginUrl();
                break;
                case 'paypal':
                    return $this->_paypal->getLoginUrl();
                break;
                case 'pinterest':
                    return $this->_pinterest->getLoginUrl();
                break;
                case 'soundcloud':
                    return $this->_soundcloud->getLoginUrl();
                break;
                case 'stackoverflow':
                    return $this->_stackoverflow->getLoginUrl();
                break;
                case 'twitter':
                    return $this->_twitter->getLoginUrl();
                break;
                case 'vimeo':
                    return $this->_vimeo->getLoginUrl();
                break;
                case 'wordpress':
                    return $this->_wordpress->getLoginUrl();
                break;
                default:
                    return '#';
                break;
            }
        }
    }

    public function getConfig($key, $default = '')
    {
        if ($this->hasData($key)) {
            return $this->getData($key);
        }
        return $default;
    }
}
